
unit midi;

{Exemplo de uso
program exemplo;
var
key:char;
phandle:=@handle;
InicioMIDI;
NoteOn(0,60,127);
Read(key);
NoteOn(0,60,0); (noteon com volume 0  o mesmo que noteoff)
MIDIFim;
fim do exemplo de uso}

interface

uses
mmsystem; {para windows e sapi, use dvcrt (veja fala.pas)}

var
nota,canal,volume:integer;
nada:MMRESULT;
handle:HMIDIOUT;
phandle:PHMIDIOUT;

procedure InicioMIDI;
procedure NoteOn(canal,nota,volume:integer);
procedure NoteOff(canal,nota:integer);
procedure ProgramChange(canal,timbre:integer);
procedure MIDIFim;

implementation

procedure InicioMIDI;
begin
nada:=midiOutOpen(phandle,MIDIMAPPER,0,0,0); {obtem Handle}
nada:=midiOutShortMsg(handle,$ff); {reset MPU}
nada:=midiOutShortMsg(handle,$3f); {modo UART}
end; {procedure InicioMIDI}

procedure NoteOn(canal,nota,volume:integer);
begin
nada:=midiOutShortMsg(handle,($90+canal+nota*256+volume*65536));
end; {procedure NoteOn}

procedure NoteOff(canal,nota:integer);
begin {outra opo  NoteOn com volume 0. neste caso, no  necessrio o status}
nada:=midiOutShortMsg(handle,($80+canal+nota*256));
if nada<>0 then writeln('erro em NoteOff');
end; {procedure NoteOff}

procedure ProgramChange(canal,timbre:integer);
begin
nada:=midiOutShortMsg(handle,($c0+canal+timbre*256));
if nada<>0 then writeln('erro em ProgramChange');
end; {procedure ProgramChange}

procedure MIDIFim;
begin
nada:=midiOutClose(handle);
end; {procedure MIDIFim}

end.
